package com.ai.android.ExerciseSystemIntents;

import java.io.IOException;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import com.ai.android.ExerciseSystemIntents.R;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.TimePickerDialog;
import android.content.ComponentName;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Resources;
import android.content.res.XmlResourceParser;
import android.net.Uri;
import android.os.Bundle;
import android.telephony.PhoneNumberFormattingTextWatcher;
import android.telephony.PhoneNumberUtils;
import android.util.Log;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.SubMenu;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ExpandableListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ExpandableListView.ExpandableListContextMenuInfo;

public class MainActivity extends Activity 
implements IStringPrompterCallBack
{
	
	private final static String L = "MainActivity";
	
	//Initialize this in onCreateOptions
	Menu myMenu = null;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //TextView tv = new TextView(this);
        //tv.setText("Hello, Android. Say hello");
        //setContentView(tv);
        
        setContentView(R.layout.main);
        
        //Before calling this method make sure
        //set the content view
        // registerForContextMenu(this.getTextView());
        this.setupButton();
        this.setupEditText();
        this.registerDialogs();
        
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) 
    {
    	//call the parent to attach any system level menus
    	super.onCreateOptionsMenu(menu);
    	
    	this.myMenu = menu;

    	MenuInflater mi = this.getMenuInflater();
    	mi.inflate(R.menu.main_menu,menu);
    	
    	//it must return true to show the menu
    	//if it is false menu won't show
    	return true;
    }
    
    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) 
    {
    	try
    	{
    		handleMenus(item);
    	}
    	catch(Throwable t)
    	{
    		Log.d(this.L,t.getMessage(),t);
    		throw new RuntimeException("error",t);
    	}
    	//should return true if the menu item
    	//is handled
    	return true;
    	
    	//If it is not our menu item
    	//let the base class handle it
        //return super.onOptionsItemSelected(item);

    }
    private void handleMenus(MenuItem item)
    {
		this.appendMenuItemText(item);
		if (item.getItemId() == R.id.menu_clear)
		{
			this.emptyText();
		}
		else if (item.getItemId() == R.id.menu_dial)
		{
			this.dial();
		}
		else if (item.getItemId() == R.id.menu_testPick)
		{
			IntentsUtils.invokePick(this);
		}
		else if (item.getItemId() == R.id.menu_testGetContent)
		{
			IntentsUtils.invokeGetContent(this);
		}
		else if (item.getItemId() == R.id.menu_show_browser)
		{
			//IntentsUtils.invokeWebBrowser(this);
			//IntentsUtils.invokeWebSearch(this);
			//IntentsUtils.dial(this);
			IntentsUtils.tryOneOfThese(this);
		}
    }
    
    private TextView getTextView()
    {
       	TextView tv = 
       		(TextView)this.findViewById(R.id.textViewId);
       	return tv;
    }
    public void appendText(String text)
    {
       	TextView tv = 
       		(TextView)this.findViewById(R.id.textViewId);
       	tv.setText(tv.getText() + text);
    }
    public void appendMenuItemText(MenuItem menuItem)
    {
    	String title = menuItem.getTitle().toString();
       	TextView tv = 
       		(TextView)this.findViewById(R.id.textViewId);
       	tv.setText(tv.getText() + "\n" + title + ":" + menuItem.getItemId());
    }
    private void emptyText()
    {
       	TextView tv = 
       		(TextView)this.findViewById(R.id.textViewId);
       	tv.setText("");
    }
    private void dial()
    {
    	Intent intent = new Intent(Intent.ACTION_DIAL);
    	intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
    	this.startActivity(intent);
    }
    private void invokeContacts()
    {
    	Intent intent = new Intent(Intent.ACTION_VIEW);
    	intent.setComponent(new ComponentName("com.android.contacts","com.android.contacts.DialtactsContactsEntryActivity"));
    	this.startActivity(intent);
    }
    private void showAllApps()
    {
    	Log.d("MainActivity", "hello this is a debug message");
    	System.out.println("hello.....");
    	Intent intent = new Intent(Intent.ACTION_ALL_APPS);
    	intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
    	this.startActivity(intent);
    }
    private void setupButton()
    {
       Button b = (Button)this.findViewById(R.id.button1);
       b.setOnClickListener(
             new Button.OnClickListener(){
                public void onClick(View v)
                {
                   parentButtonClicked(v);
                }
             });
       
    }
    private void parentButtonClicked(View v)
    {
       this.appendText("\nbutton clicked");
       this.dialUsingEditText();
    }
    
    private void dialWithNumber(String tel)
    {
    	String  telUriString = "tel:" + tel;
    	Log.d(L, telUriString);
    	Intent intent = new Intent(Intent.ACTION_DIAL);
    	intent.setData(Uri.parse(telUriString));
    	intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
    	this.startActivity(intent);
    }
    
    private void dialUsingEditText()
    {
    	EditText etext = 
    		(EditText)this.findViewById(R.id.editTextId);
    	String text = etext.getText().toString();
    	if (PhoneNumberUtils.isGlobalPhoneNumber(text) == false)
    	{
    		//Dialog d = this.getOkDialog("problem");
    		//d.show();
    	}
    	//Alert.show("message", this);
    	//dialWithNumber(text);
    	//this.exercisePrompt();
    	//this.exerciseAlertDialog();
    	this.exerciseDialogRegistry();
    }
    private EditText getEditText()
    {
    	EditText etext = 
    		(EditText)this.findViewById(R.id.editTextId);
    	return etext;
    }
    private void setupEditText()
    {
    	EditText etext = this.getEditText();
    	etext.addTextChangedListener(new PhoneNumberFormattingTextWatcher());
    }
    
	public void promptCallBack(String promptedString, 
			int buttonPressed, //which button was pressed 
			int actionId) //To support multiple prompts
	{
		if (buttonPressed == IStringPrompterCallBack.OK_BUTTON)
		{
			this.appendText("\nprompted string is:" + promptedString);
		}
		else
		{
			this.appendText("\nCancel has been pressed instead");
		}
	}
	private void exercisePrompt()
	{
		Alert.Prompt(this,"Please enter a filename", this,1);
	}
	
	//Dialog support
	private static final int DIALOG_ALERT_ID = 1;
	private static final int DIALOG_ALERT_ID_3 = 3;
	private int alertDemoCounter=0;
	private static final int DIALOG_PROMPT_ID = 2;
	
    @Override
    protected Dialog onCreateDialog(int id) {
        switch (id) {
            case DIALOG_ALERT_ID: 
            	return createAlertDialog();
            default:
            	return this.dr.create(id);
        }
    }
    @Override
    protected void onPrepareDialog(int id, Dialog dialog) {
        switch (id) {
        case DIALOG_ALERT_ID: 
        		prepareAlertDialog(dialog);
        	default:
        		this.dr.prepare(dialog, id);
        }
    }
   
    //set this 
    private String dynamicMessage = "Initial Message";
    private Dialog createAlertDialog()
    {
    	return Alert.createAlertDialog(dynamicMessage, this);
    }
    
    private void prepareAlertDialog(Dialog d)
    {
    	AlertDialog ad = (AlertDialog)d;
    	ad.setMessage(dynamicMessage);
    }
    private void exerciseAlertDialog()
    {
    	this.dynamicMessage="Dynamic Message:" + alertDemoCounter++;
    	showDialog(this.DIALOG_ALERT_ID);
    }
    
    //DialogRegistry idea
    private DialogRegistry dr = new DialogRegistry();
	private GenericManagedAlertDialog gmad = 
		new GenericManagedAlertDialog(this,"InitialValue");
    
    private void registerDialogs()
    {
    	dr.registerDialog(this.DIALOG_ALERT_ID_3, gmad);
    }
    private void exerciseDialogRegistry()
    {
    	gmad.setAlertMessage("some message:" + this.alertDemoCounter++);
    	showDialog(this.DIALOG_ALERT_ID_3);
    }

    protected void onActivityResult(int requestCode
    	,int resultCode
    	,Intent outputIntent)
    {
    	super.onActivityResult(requestCode, resultCode, outputIntent);
    	IntentsUtils.parseResult(this, requestCode, resultCode, outputIntent);
    }

    
}//eof-class